// IShopServiceBinder.aidl
package com.picsart.shopNew.lib_shop.service;

// Declare any non-default types here with import statements
import com.picsart.shopNew.lib_shop.callback.IGetShopBundlesCallBack;
import com.picsart.shopNew.lib_shop.callback.IGetShopItemsListCallBack;
import com.picsart.shopNew.lib_shop.callback.IGetShopItemCallBack;
import com.picsart.shopNew.lib_shop.callback.IGetShopCategoriesCallBack;
import com.picsart.shopNew.lib_shop.callback.IGetShopTagsCallBack;
import com.picsart.shopNew.lib_shop.callback.IGetShopItemPriceCallBack;
import com.picsart.shopNew.lib_shop.callback.IGetShopBundlePriceCallBack;
import com.picsart.shopNew.lib_shop.callback.IGetShopBannersCallBack;
import com.picsart.shopNew.lib_shop.callback.ISearchShopItemsCallBack;
import com.picsart.shopNew.lib_shop.callback.IGetShopCardsCallBack;
import com.picsart.shopNew.lib_shop.callback.IShopServiceListener;
import com.picsart.shopNew.lib_shop.callback.IShopMainCardsCallBack;
import com.picsart.shopNew.lib_shop.callback.IGetShopItemsListCallBack;
import com.picsart.shopNew.lib_shop.callback.IUpdateShopPackageCallBack;
import com.picsart.shopNew.lib_shop.domain.ShopItem;
import com.picsart.shopNew.lib_shop.domain.ShopBundle;
import com.picsart.shopNew.lib_shop.utils.ShopPackageQuery;
import com.picsart.common.packfile.PackFileDownloadListener;


interface IShopServiceBinder {


    void syncShopItems(boolean forceSync);
    
    void syncShopItemPrices();
    
  	void requestShopBundles(IGetShopBundlesCallBack callBack);
    
    void getShopItemsList(in ShopPackageQuery query, IGetShopItemsListCallBack getShopItemsListCallBack);

    void getClipArtFeaturedShopPackages(int maxCount, IGetShopItemsListCallBack getShopItemsListCallBack);

    void updateShopPackage(in ShopItem shopItem, IUpdateShopPackageCallBack callBack);
    
    void getShopItem(String shopItemUID, IGetShopItemCallBack getShopItemCallBack);
    
    void getShopCategories(IGetShopCategoriesCallBack callBack);

    void getShopTags(IGetShopTagsCallBack callBack);

    void getShopItemPrice(in ShopItem shopItem, IGetShopItemPriceCallBack callBack);
    
    void getShopBundlePrice(in ShopBundle shopBundle, IGetShopBundlePriceCallBack callBack);

    void getAllShopItemsOfCard(String type, String contentType, IGetShopItemsListCallBack callBack);

    void requestShopBanners(IGetShopBannersCallBack callBack);

    void searchShopItems(String keyword, String type, String contentType, String language, ISearchShopItemsCallBack callBack);

    void getShopCards(String type, String contentType, IGetShopCardsCallBack callBack);
    
    void addServiceListener(String tag, IShopServiceListener listener) ;

    void removeShopServiseListener(String tag);
    
    void requestUserShopItems(String apiKey, IGetShopItemsListCallBack callBack);
    
    void addShopPackage(in ShopItem shopItem, String userKey);

    void downloadShopItem(in ShopItem shopItem, PackFileDownloadListener downloadlistener);

    void getSimilarPackages(in ShopItem shopItem,  IGetShopItemsListCallBack callBack);

    void getPopularPackages(IGetShopItemsListCallBack callBack);

    void getShopCardsForTab(String tabId, IShopMainCardsCallBack callBack);

    PackFileDownloadListener setShopItemDownloadListener(in ShopItem shopItem, PackFileDownloadListener downloadlistener);
    PackFileDownloadListener setShopItemPendingDownloadListener(in ShopItem shopItem, PackFileDownloadListener downloadlistener);

    boolean isShopPackageDownloading(in ShopItem shopItem);
    boolean isShopPackageDownloadPending(in ShopItem shopItem);

    void updateNewClipartCategoryStatus(boolean isNew);
    void updateNewTextArtCategoryStatus(boolean isNew);
    void updateNewFrameCategoryStatus(boolean isNew);
    void updateNewMaskCategoryStatus(boolean isNew);
    void updateNewCollageFrameCategoryStatus(boolean isNew);
    void updateNewBackgroundCategoryStatus(boolean isNew);

    boolean hasNewClipartCategory();
    boolean hasNewTextArtCategory();
    boolean hasNewFrameCategory();
    boolean hasNewMaskCategory();
    boolean hasNewCollageFrameCategory();
    boolean hasNewBackgroundCategory();

    boolean isShopItemsExists();



}
