#pragma version(1)
#pragma rs java_package_name(com.picsart.effects.rs)

static float selectedL;
static float selectedA;
static float selectedB;

static float _lightness = 2.0;
static float _chroma = 1.0;


void set_calculate_diff_params(int x,int y,rs_allocation labData){
	float3* selectedLAB = (float3*)rsGetElementAt(labData, x, y);
	selectedL = selectedLAB->s0;
	selectedA = selectedLAB->s1;
	selectedB = selectedLAB->s2;
}

static void rgbToLab(uchar red,uchar green,uchar blue,float lab[3]){

	float var_R = (float) red / (float) 255;
 	float var_G = (float) green / (float) 255;
 	float var_B = (float) blue / (float) 255;

 	if (var_R > (float) 0.04045)
 		var_R = pow(((var_R + (float) 0.055) / (float) 1.055), (float) 2.4);
 	else
 		var_R = var_R / (float) 12.92;
 	if (var_G > (float) 0.04045)
 		var_G = pow(((var_G + (float) 0.055) / (float) 1.055), (float) 2.4);
 	else
 		var_G = var_G / (float) 12.92;
 	if (var_B > (float) 0.04045)
 		var_B = pow(((var_B + (float) 0.055) / (float) 1.055), (float) 2.4);
 	else
 		var_B = var_B / (float) 12.92;

 	var_R = var_R * (float) 100;
 	var_G = var_G * (float) 100;
 	var_B = var_B * (float) 100;

 	float XYZ[3];
 	float xyzX = var_R * (float) 0.4124 + var_G * (float) 0.3576
 			+ var_B * (float) 0.1805;
 	float xyzY = var_R * (float) 0.2126 + var_G * (float) 0.7152
 			+ var_B * (float) 0.0722;
 	float xyzZ = var_R * (float) 0.0193 + var_G * (float) 0.1192
 			+ var_B * (float) 0.9505;

 	float var_X = xyzX / (float) 95.047;
 	float var_Y = xyzY / (float) 100.000;
 	float var_Z = xyzZ / (float) 108.883;

 	if (var_X > (float) 0.008856)
 		var_X = pow(var_X, (float) 1 / (float) 3);
 	else
 		var_X = ((float) 7.787 * var_X) + ((float) 16 / (float) 116);
 	if (var_Y > (float) 0.008856)
 		var_Y = pow(var_Y, ((float) 1 / (float) 3));
 	else
 		var_Y = ((float) 7.787 * var_Y) + (float) 16 / (float) 116;
 	if (var_Z > (float) 0.008856)
 		var_Z = pow(var_Z, (float) 1 / (float) 3);
 	else
 		var_Z = ((float) 7.787 * var_Z) + (float) 16 / (float) 116;

 	float CIE_a = (float) 500 * (var_X - var_Y);
 	float CIE_b = (float) 200 * (var_Y - var_Z);
 	
 	lab[0] = ((float) 116) * var_Y - (float) 16;
 	lab[1] = CIE_a;
 	lab[2] = CIE_b;
}


static float CIE94Diff(const float L1, const float a1, const float b1,
		const float L2, const float a2, const float b2) {

	float deltaL = L1 - L2;
	float deltaA = a1 - a2;
	float deltaB = b1 - b2;

	float c1 = sqrt(pow(a1, 2) + pow(b1, 2));
	float c2 = sqrt(pow(a2, 2) + pow(b2, 2));
	float deltaC = c1 - c2;

	float deltaH = pow(deltaA, 2) + pow(deltaB, 2) - pow(deltaC, 2);
	deltaH = deltaH < 0 ? 0 : sqrt(deltaH);

	const float sl = 1.0;
	const float kc = 1.0;
	const float kh = 1.0;

	float Kl = 2.0;
	float K1 = .048;
	float K2 = .014;
	
	/*
	float Kl = 1.0;
	float K1 = .045;
	float K2 = .015;*/

	float sc = 1.0 + K1 * c1;
	float sh = 1.0 + K2 * c1;

	float i = pow(deltaL / (Kl * sl), 2) + pow(deltaC / (kc * sc), 2)
			+ pow(deltaH / (kh * sh), 2);
	float finalResult = i < 0 ? 0 : sqrt(i);

	return finalResult;

}

static float CIE76Diff(const float L1, const float a1, const float b1,
		const float L2, const float a2, const float b2){
		
		float deltaL = L1 - L2;
		float deltaA = a1 - a2;
		float deltaB = b1 - b2;
		float deltaE2 = deltaL*deltaL + deltaA*deltaA + deltaB*deltaB;
		return sqrt(deltaE2);
}

/*
	float hue1 = atan2pi(b1, a1)*180.f;
	if(hue1 < 0.f){
		hue1 += 360.f;
	}else if(hue1 > 360.f){
		hue1 -= 360.f;
	}
	
	float hue2 = atan2pi(b2, a2)*180.f;
	if(hue2 < 0.f){
		hue2 += 360.f;
	}else if(hue2 > 360.f){
		hue2 -= 360.f;
	}
	
	
	if(fabs(hue1 - hue2) < 180){
		deltaH = fabs(hue1 - hue2)/180.f*100.f;
	}else{
		if(hue1 > hue2){
			deltaH = ((360.f - hue1)+hue2)/180.f*100.f;
		}else{
			deltaH = ((360.f - hue2)+hue1)/180.f*100.f;
		}
	}
	
	hueDiff = hueDiff*2;
	
	kh = hueDiff;*/

static float DistanceDivided(float a, float dividend){
            float adiv = a / dividend;
            return adiv * adiv;
}

static float CMCDiff(const float L1, const float a1, const float b1,
		const float L2, const float a2, const float b2){
		
		float c1 = sqrt(a1*a1 + b1*b1);
		float c2 = sqrt(a2*a2 + b2*b2);
		float deltaC = c1 - c2;
		
		float deltaL = L1 - L2;
		float deltaA = a1 - a2;
		float deltaB = b1 - b2;
		float deltaH = sqrt(deltaA*deltaA + deltaB*deltaB - deltaC*deltaC);
		
		float hue1 = atan2pi(b1, a1)*180.f;
		if(hue1 < 0.f){
			hue1 += 360.f;
		}else if(hue1 > 360.f){
			hue1 -= 360.f;
		}
		
		/*
		rsDebug("deltaA = ",deltaA);
		rsDebug("deltaB = ",deltaB);
		rsDebug("deltaC = ",deltaC);
		rsDebug("deltaH = ",deltaH);
		rsDebug("hue1 = ",hue1);*/
		
		float t = 0;
		if(hue1 >= 164.f && hue1 <= 345.f){
			hue1 += 168.f;
			if(hue1 > 360.f){
				hue1 -= 360.f;
			}
			t = 0.56f + fabs(0.2f*cospi(hue1/180.f));
			
		}else{
			hue1 += 35.f;
			if(hue1 > 360.f){
				hue1 -= 360.f;
			}
			t = 0.36f + fabs(0.4f*cospi(hue1/180.f));
		}
		
		float c14 = c1*c1;
		c14 *= c14;
		float f = sqrt((c14/(c14 + 1900.f)));
		
		float sl = 0;
		if(L1 < 16.f){
			sl = 0.511f;
		}else{
			sl = 0.040975f*L1/(1.f + 0.01765f*L1);
		}
		
		float sc = 0.0638f*c1/(1.f + 0.0131f*c1) + 0.638f;
		float sh = sc*(f*t+1.f - f);
		
		float d1 = deltaL/(_lightness*sl);
		float d2 = deltaC/(_chroma*sc);
		float d3 = deltaH/sh;
		
		float deltaE2 = d1*d1 + d2*d2 + d3*d3;
		float deltaE = sqrt(deltaE2);
		

	return deltaE;
}

void debugDiffs(int red1,int green1,int blue1,
					int red2,int green2,int blue2){
					
	rsDebug("red1 = ",red1);
	rsDebug("green1 = ",green1);
	rsDebug("blue1 = ",blue1);
	
	rsDebug("red2 = ",red2);
	rsDebug("green2 = ",green2);
	rsDebug("blue2 = ",blue2);
	
	float lab1[3];
	rgbToLab(red1,green1,blue1,lab1);
	float lab2[3];
	rgbToLab(red2,green2,blue2,lab2);
	
	rsDebug("L1 = ",lab1[0]);
	rsDebug("A1 = ",lab1[1]);
	rsDebug("B1 = ",lab1[2]);
	
	rsDebug("L2 = ",lab2[0]);
	rsDebug("A2 = ",lab2[1]);
	rsDebug("B2 = ",lab2[2]);
	
	float cmcDiff = CMCDiff(lab1[0], lab1[1], lab1[2],
		lab2[0], lab2[1], lab2[2]);
	rsDebug("cmcDiff = ",cmcDiff);
	
	float cie94Diff = CIE94Diff(lab1[0], lab1[1], lab1[2],
		lab2[0], lab2[1], lab2[2]);
	rsDebug("cie94Diff = ",cie94Diff);

}


void root(const float3* labData,float *v_out, uint32_t x, uint32_t y)
{
	
	float l = labData->s0;
	float a = labData->s1;
	float b = labData->s2;
	
	*v_out = CIE76Diff(l, a, b,selectedL, selectedA, selectedB);
}


