
#pragma version(1)
#pragma rs java_package_name(com.picsart.effects.rs)

#include "rs_utils.rsh"

static uchar red_lut[256];
static uchar green_lut[256];
static uchar blue_lut[256];

void set_params_crossprocessing(float contrast, float amount, int mode) {
    Corrector cor_r;
    Corrector cor_g;
    Corrector cor_b;

    switch (mode) {
        case 2:
            cor_r = newCorrector5(amount / 2.f);
            cor_g = cor_r;
            cor_b = newCorrector5(amount);
            break;
        case 1:
        default:
            cor_r = newCorrector5(amount);
            cor_g = cor_r;
            cor_b = newCorrector2(amount);
    }

    const int b = 255.f * (1.f - contrast / 2.f);
    const int a = 255 - b;

    const uchar cor_r_0 = cor_r.correct(0, cor_r.param);
    const uchar cor_g_0 = cor_g.correct(0, cor_g.param);
    const uchar cor_b_0 = cor_b.correct(0, cor_b.param);

    for (int i = 0; i < a; i++) {
        red_lut[i] = cor_r_0;
        green_lut[i] = cor_g_0;
        blue_lut[i] = cor_b_0;
    }

    for (int i = a; i <= b; i++) {
        red_lut[i] = cor_r.correct(255.f * (i - a) / (b - a), cor_r.param);
        green_lut[i] = cor_g.correct(255.f * (i - a) / (b - a), cor_g.param);
        blue_lut[i] = cor_b.correct(255.f * (i - a) / (b - a), cor_b.param);
    }

    const uchar cor_r_255 = cor_r.correct(255, cor_r.param);
    const uchar cor_g_255 = cor_g.correct(255, cor_r.param);
    const uchar cor_b_255 = cor_b.correct(255, cor_r.param);

    for (int i=(b+1); i<256; i++) {
        red_lut[i] = cor_r_255;
        green_lut[i] = cor_g_255;
        blue_lut[i] = cor_b_255;
    }
}

void root(const uchar4 *v_in, uchar4 *v_out) {
    *v_out = (uchar4){red_lut[v_in->r], green_lut[v_in->g], blue_lut[v_in->b], 255};
}

