
#pragma version(1)
#pragma rs java_package_name(com.picsart.effects.rs)

#include "rs_utils.rsh"

static uchar blend_func_exclusion(const uchar Sc, const uchar Dc) {
    return Sc + Dc - 2 * Sc * Dc / 255;
}

void root(uchar4 *v_out, uint32_t x, uint32_t y) {
    int r = v_out->r;
    int g = v_out->g;
    int b = v_out->b;

    // Channel mixer.
    {
        r = SATURATE_CAST_TO_UCHAR(( 98 * r + 10 * g -  10 * b) / 100);
        b = SATURATE_CAST_TO_UCHAR((-12 * r +  8 * g + 104 * b) / 100);
    }

    // Fill layer, color: #381f09; opcaity 25%; blending: lighten.
    // Fill layer, color: #660011; opacity 12%; blending:exclusion.
    {
        r = (max(56, r) + r * 3) / 4;
        g = (max(31, g) + g * 3) / 4;
        b = (max( 9, b) + b * 3) / 4;

        r = (blend_func_exclusion(102, r) * 3 + r * 22) / 25;
        g = (blend_func_exclusion(  0, g) * 3 + g * 22) / 25;
        b = (blend_func_exclusion( 17, b) * 3 + b * 22) / 25;
    }

    *v_out = (uchar4){r, g, b, 255};
}
