
#pragma version(1)
#pragma rs java_package_name(com.picsart.effects.rs)

#include "rs_utils.rsh"

static uchar blend_func_exclusion(const uchar Sc, const uchar Dc) {
    return Sc + Dc - 2 * Sc * Dc / 255;
}

void root(uchar4 *v_out, uint32_t x, uint32_t y) {
    int r = v_out->r;
    int g = v_out->g;
    int b = v_out->b;

    // Channel mixer.
    {
        r = SATURATE_CAST_TO_UCHAR(( 98 * r + 10 * g -  10 * b) / 100);
        b = SATURATE_CAST_TO_UCHAR((-12 * r +  8 * g + 104 * b) / 100);
    }

    // Fill layer, color: #660011; opacity 30%; blending:exclusion.
    {
        r = (blend_func_exclusion( 2, r) * 3 + r * 7) / 10;
        g = (blend_func_exclusion(12, g) * 3 + g * 7) / 10;
        b = (blend_func_exclusion(39, b) * 3 + b * 7) / 10;
    }

    *v_out = (uchar4){r, g, b, 255};
}
