
#pragma version(1)
#pragma rs java_package_name(com.picsart.effects.rs)

#include "rs_utils.rsh"

static int cx, cy, rad, rad2;
static uchar BG_COLOR, FG_COLOR;
static const int FOCALSOFTEN_MODE_DIRECT = 2;

void set_params_focalsoften(rs_allocation source, int center_x, int center_y, int radius, int mode) {
    const int W = rsAllocationGetDimX(source);
    const int H = rsAllocationGetDimY(source);
    rad = max(1, radius * W / 200);
    rad2 = rad * rad;
    cx = center_x * W / 100;
    cy = center_y * H / 100;
    BG_COLOR = (mode == FOCALSOFTEN_MODE_DIRECT) ? 255 : 0;
    FG_COLOR = (mode == FOCALSOFTEN_MODE_DIRECT) ? 0 : 255;
}

void root(uchar *v_out, uint32_t x, uint32_t y) {
    if ((abs((int)x - cx) <= rad) && (abs((int)y - cy) <= rad))
        *v_out =  ((x - cx) * (x - cx) + (y - cy) * (y - cy)) <= rad2 ? BG_COLOR : FG_COLOR;
    else
        *v_out = FG_COLOR;
}
