
#pragma version(1)
#pragma rs java_package_name(com.picsart.effects.rs)

#include "rs_utils.rsh"

static rs_allocation src;
static int maxW, maxH, cx, cy;
static float blure;
static int kx0[105];
static int kx1[105];
static int ky0[105];
static int ky1[105];
static int ka[106];
static int n;

void set_params_focalzoom(rs_allocation source, int center_x, int center_y, int amount) {
    const int W = rsAllocationGetDimX(source);
    const int H = rsAllocationGetDimY(source);
    maxW = W - 1;
    maxH = H - 1;

    src = source;

    cx = center_x * W / 100;
    cy = center_y * H / 100;
    blure = W * amount / 200.f;
    n = (int) min(30.f, 5 + blure);
    float alpha = 0.15f;
    float oma = 1.f - alpha;

    ka[n] = pow(oma, n) * 255;
    for (int i = n - 1; i >= 0; --i) {
        float dS = blure * (i + 1) / n;
        kx0[i] = (int) round(100.f * W / (W + dS));
        kx1[i] = (int) round(cx * dS / (W + dS));
        ky0[i] = (int) round(100.f * H / (H + dS));
        ky1[i] = (int) round(cy * dS / (H + dS));
        ka[i] = pow(oma, i) * alpha * 255;
    }

}

void root(const uchar4 *v_in, uchar4 *v_out, uint32_t x, uint32_t y) {
    int kai = ka[n];

    int r = v_in->r * kai;
    int g = v_in->g * kai;
    int b = v_in->b * kai;

    for (int i = n - 1; i >= 0; --i) {
        int xx = min((int)maxW, (int)(x * kx0[i] / 100 + kx1[i]));
        int yy = min((int)maxH, (int)(y * ky0[i] / 100 + ky1[i]));

        const uchar4* sp = getUChar4(src, yy, xx);
        kai = ka[i];

        r += sp->r * kai;
        g += sp->g * kai;
        b += sp->b * kai;
    }

    *v_out = (uchar4) { r / 255,
                        g / 255,
                        b / 255,
                        255 };
}
