#pragma version(1)
#pragma rs java_package_name(com.picsart.effects.rs)

#include "rs_utils.rsh"

static int w, dr, dl;
static rs_allocation img;
static int sdiv_table[256];
static int hdiv_table[256];
static const int hsv_shift = 12;

void set_params_holgaart1(rs_allocation image, int l, int r) {
    sdiv_table[0] = hdiv_table[0] = 0;
	for(int i = 1; i < 256; i++ ) {
		sdiv_table[i] = (int) ((255 << hsv_shift)/(1.f * i));
		hdiv_table[i] = (int) ((180 << hsv_shift)/(6.f * i));
	}

	img = image;

	w = rsAllocationGetDimX(image);
	const int h = rsAllocationGetDimY(image);
    dr = r * w / 200;
    dl = l  * w / 200;
}

static uchar4 get_rd(int x, int y)
{
    const uchar4* sp = getUChar4(img, y, x);

    const int r = sp->r;
    const int g = sp->g;
    const int b = sp->b;

    const int v = max(max(r, g), b);
    const int s = SATURATE_CAST_TO_UCHAR((((v - min(min(r, g), b)) * sdiv_table[v] + (1 << (hsv_shift-1))) >> hsv_shift) + 5);

    const int vr = SATURATE_CAST_TO_UCHAR(v - 5);
    const int vr2 = vr*(255 - s)/255;

    return (uchar4){vr, vr2, vr2, 255};
}

static uchar4 get_cn(int x, int y)
{
    const uchar4* sp = getUChar4(img, y, x);

    const int r = sp->r;
    const int g = sp->g;
    const int b = sp->b;

    const int v = max(max(r, g), b);
    const int s = SATURATE_CAST_TO_UCHAR((((v - min(min(r, g), b)) * sdiv_table[v] + (1 << (hsv_shift-1))) >> hsv_shift) + 5);

    const int vc = v;
    const int vc2 = vc*(255 - s)/255;

    return (uchar4){vc2, vc, vc, 255};
}

void root(uchar4 *v_out, uint32_t x, uint32_t y) {
	if (x < dr)
		*v_out = hard(get_rd(x + dl, y), get_cn(x + w - dr, y));
	else if (x < w - dl)
		*v_out = hard(get_rd(x + dl, y), get_cn(x - dr, y));
	else
		*v_out = hard(get_rd(x - w + dl, y), get_cn(x - dr, y));
}
