#pragma version(1)
#pragma rs java_package_name(com.picsart.effects.rs)

#include "rs_utils.rsh"

static rs_allocation overlay, out, tmp;
static int w, h;
static uchar lut[256];
static int left_x, left_y;

void set_params_holgaart4_1(rs_allocation output, rs_allocation over, rs_allocation temp, int l)
{
	overlay = over;
	out = output;
	tmp = temp;

	w = rsAllocationGetDimX(output);
	h = rsAllocationGetDimY(output);

    left_x = w * (100 - l) / 100.f;
    left_y = h * 0.045f;

    const size_t UPPER_BOUND = 128;
    for (size_t i = 0; i < UPPER_BOUND; i++) {
        lut[i] = 255 * i / UPPER_BOUND;
    }
    for (size_t i = UPPER_BOUND; i < 256; i++) {
        lut[i] = 255;
    }
}

void root(const uchar4 *v_in, uint32_t x, uint32_t y) {
	int ii = (y < h - left_y) ? (y + left_y) : (y - h + left_y);
	int jj = (x < w - left_x) ? (x + left_x) : (x - w + left_x);

    *getUChar4(tmp, ii, jj) = *v_in;
    const uchar4 over = getValUChar4(overlay, ii, jj);
    *getUChar4(out, ii, jj) =  (uchar4){over.r * lut[v_in->r] / 255,
                                        over.g * lut[v_in->g] / 255,
                                        over.b * lut[v_in->b] / 255,
                                        255};
}
