
#pragma version(1)
#pragma rs java_package_name(com.picsart.effects.rs)

#include "rs_utils.rsh"

static uchar h, s, val;
static const uchar sector_data[][3] = {{0,3,1}, {2,0,1}, {1,0,3}, {1,2,0}, {3,1,0}, {0,1,2}};
static const uchar* current_sector_data;

void set_params_motionblur_1(int hue, int sat, int value) {
    h = hue % 180;
	s = SATURATE_CAST_TO_UCHAR(255 * sat / 50);
	val = value;

    int sector = h / 30;
    current_sector_data = sector_data[sector];
    h = h % 30;
}

void root(const uchar4 *v_in, uchar4 *v_out, uint32_t x, uint32_t y) {
    uchar gray = DESCALE(v_in->r * RGB2YCC_C0  +  v_in->g * RGB2YCC_C1  +  v_in->b * RGB2YCC_C2, YCC_SHIFT);
    uchar v = SATURATE_CAST_TO_UCHAR(gray * val / 50);

	if( s == 0 ) {
		*v_out = (uchar4) {	v, v, v, 255 };
	}
	else {
	    uchar tab[4];
		tab[0] = v;
		tab[1] = v * (255 - s) / 255;
		tab[2] = v * (255 - s * h / 30) / 255;
		tab[3] = v * (255 - s * (30 - h) / 30) / 255;

		*v_out = (uchar4) {	tab[current_sector_data[0]],
							tab[current_sector_data[1]],
							tab[current_sector_data[2]],
							255 };
	}
}
