
#pragma version(1)
#pragma rs java_package_name(com.picsart.effects.rs)

#include "rs_utils.rsh"

static rs_allocation src;
static int W, H;

static int dist;
static int noise;
static int angle;
static int dx;
static int dy;
static int i_beg;
static int i_end;
static int inv_noise;
static int RAND;

void set_params_motionblur_2(rs_allocation source, int dist_a, int noise_a, int angle_a) {
    W = rsAllocationGetDimX(source);
    H = rsAllocationGetDimY(source);

    src = source;

    dist = (int) (min(W, H) * dist_a / 1000.f);
    noise = noise_a;
    angle = angle_a;
	dx = dist * cos(M_PI * angle / 180);
	dy = dist * sin(M_PI * angle / 180);
    i_beg = - dist / 2;
    i_end = + dist / 2;
    inv_noise = 100 - noise;
    RAND = angle;
}

void root(uchar4 *v_out, uint32_t x, uint32_t y) {

    int parts_sum_r;
    int parts_sum_g;
    int parts_sum_b;

	parts_sum_r = 0;
	parts_sum_g = 0;
	parts_sum_b = 0;

	int i_lim = 0;

	for (int i = i_beg; i < i_end; ++i) {
		const int xx = x + i * dx / dist;
		const int yy = y + i * dy / dist;

		if (xx < 0 || yy < 0 || xx >= W || yy >= H)
			continue;

		++i_lim;

		const uchar4 *sp = getUChar4(src, yy, xx);
		parts_sum_r += sp->r;
		parts_sum_g += sp->g;
		parts_sum_b += sp->b;
	}

	const int noise_val = noise * rsRand(255);

	const uchar4 color = getValUChar4(src, y, x);
	if (i_lim) {
		*v_out = (uchar4) {	SATURATE_CAST_TO_UCHAR((inv_noise * parts_sum_r / i_lim + noise_val) / 100),
							SATURATE_CAST_TO_UCHAR((inv_noise * parts_sum_g / i_lim + noise_val) / 100),
							SATURATE_CAST_TO_UCHAR((inv_noise * parts_sum_b / i_lim + noise_val) / 100),
							255 };
	}
	else {
		*v_out = (uchar4) {	SATURATE_CAST_TO_UCHAR((inv_noise * color.r + noise_val) / 100),
							SATURATE_CAST_TO_UCHAR((inv_noise * color.g + noise_val) / 100),
							SATURATE_CAST_TO_UCHAR((inv_noise * color.b + noise_val) / 100),
							255 };

	}
}
