
#pragma version(1)
#pragma rs java_package_name(com.picsart.effects.rs)

#include "rs_utils.rsh"

static rs_allocation scr, blr;
static int upper_intensity, lower_intensity;
static int bound_diff;
static float scale_factor;
static float shift;
static uchar lut[256];

void set_params_orton_2(rs_allocation screen, rs_allocation blured, int upper, int lower) {
    scr = screen;
    blr = blured;

    float k = 255.f / (upper - lower);
    float b = -255.f * lower / (upper - lower);

    for (int x = 0; x < 256; x++)
        lut[x] = SATURATE_CAST_TO_UCHAR(k * x + b);
}

void root(uchar4 *v_out, uint32_t x, uint32_t y) {
    const uchar4 cur_scr = getValUChar4(scr, y, x);
    const uchar4 cur_blr = getValUChar4(blr, y, x);

    *v_out = (uchar4){  lut[(int)cur_scr.r * cur_blr.r / 255],
                        lut[(int)cur_scr.g * cur_blr.g / 255],
                        lut[(int)cur_scr.b * cur_blr.b / 255],
                        255  };
}
