
#pragma version(1)
#pragma rs java_package_name(com.picsart.effects.rs)

#include "rs_utils.rsh"

static rs_allocation src, or_x, or_y;
static int W, H;


void set_params_pencil_1(rs_allocation source, rs_allocation orient_x, rs_allocation orient_y) {
    W = rsAllocationGetDimX(source);
    H = rsAllocationGetDimY(source);

    src = source;
    or_x = orient_x;
    or_y = orient_y;
}

static void detectOrientation(const int a_x, const int a_y, const int b_x, const int b_y, const int c_x, const int c_y, const int d_x, const int d_y, float* const r_x, float* const r_y) {
    //All possible vectors sum are tested (vectors +v and -v give the same orientation, so, the "-a" at the first place is not tested).
    int maxSum_x = a_x;
    maxSum_x += b_x;
    maxSum_x += c_x;
    maxSum_x += d_x;

    int maxSum_y = a_y;
    maxSum_y += b_y;
    maxSum_y += c_y;
    maxSum_y += d_y;

    int maxLen = maxSum_x * maxSum_x + maxSum_y * maxSum_y;

    {
        int sum_x = maxSum_x;
        int sum_y = maxSum_y;

        int b2_x = b_x * 2;
        int b2_y = b_y * 2;
        int c2_x = c_x * 2;
        int c2_y = c_y * 2;
        int d2_x = d_x * 2;
        int d2_y = d_y * 2;

        int len;

        sum_x -= d2_x; sum_y -= d2_y;
        len = sum_x * sum_x + sum_y * sum_y;
        if(len > maxLen) { maxSum_x = sum_x; maxSum_y = sum_y; maxLen = len; }

        sum_x -= c2_x; sum_y -= c2_y;
        len = sum_x * sum_x + sum_y * sum_y;
        if(len > maxLen) { maxSum_x = sum_x; maxSum_y = sum_y; maxLen = len; }

        sum_x += d2_x; sum_y += d2_y;
        len = sum_x * sum_x + sum_y * sum_y;
        if(len > maxLen) { maxSum_x = sum_x; maxSum_y = sum_y; maxLen = len; }

        sum_x -= b2_x; sum_y -= b2_y;
        len = sum_x * sum_x + sum_y * sum_y;
        if(len > maxLen) { maxSum_x = sum_x; maxSum_y = sum_y; maxLen = len; }

        sum_x -= d2_x; sum_y -= d2_y;
        len = sum_x * sum_x + sum_y * sum_y;
        if(len > maxLen) { maxSum_x = sum_x; maxSum_y = sum_y; maxLen = len; }

        sum_x += c2_x; sum_y += c2_y;
        len = sum_x * sum_x + sum_y * sum_y;
        if(len > maxLen) { maxSum_x = sum_x; maxSum_y = sum_y; maxLen = len; }

        sum_x += d2_x; sum_y += d2_y;
        len = sum_x * sum_x + sum_y * sum_y;
        if(len > maxLen) { maxSum_x = sum_x; maxSum_y = sum_y; maxLen = len; }

        if( !maxLen ) { *r_x = 0; *r_y = 0; return; }
    }

    //The orientation direction is vector combination giving maximum sum. But to calculate orientation
    //  strength, additional computations are needed. The normal vector should be tested, and orientation
    //  strength along this normal vector should be subtracted from the current orientation strength.
    const float maxLenF = sqrt((float)maxLen);
    float unit_x = maxSum_x;
    float unit_y = maxSum_y;
    unit_x /= maxLenF;
    unit_y /= maxLenF;

    float normal_x = -unit_y;
    float normal_y = unit_x;

    const float normalSum = fabs(normal_x * a_x + normal_y * a_y) +
                            fabs(normal_x * b_x + normal_y * b_y) +
                            fabs(normal_x * c_x + normal_y * c_y) +
                            fabs(normal_x * d_x + normal_y * d_y);

    //That is the moment when vector becomes orientation: angle doubling.
    float tmp = unit_x * unit_x - unit_y * unit_y;
    unit_y = unit_x * unit_y * 2;
    unit_x = tmp;

    tmp = maxLenF - normalSum;
    *r_x = unit_x * tmp;
    *r_y = unit_y * tmp;
}

void root(const uchar *v_in, uint32_t x, uint32_t y) {

    const uchar * sLIn  = getRowUChar(src, y);
    const uchar * sLIn1 = (y == 0) ? sLIn : getRowUChar(src, y - 1);
    const uchar * sLIn2 = (y + 1 == H) ? sLIn : getRowUChar(src, y + 1);

    float * sLOut_x = getFloat(or_x, y, x);
    float * sLOut_y = getFloat(or_y, y, x);

	const int x1 = max((int)x - 1, 0);
	const int x2 = min((int)x + 1, W - 1);

	const int c1 = sLIn1[x1], c2 = sLIn1[x], c3 = sLIn1[x2];
	const int c4 = sLIn [x1], c5 = sLIn [x], c6 = sLIn [x2];
	const int c7 = sLIn2[x1], c8 = sLIn2[x], c9 = sLIn2[x2];

	detectOrientation(c2 + c5 - c1 - c4, c4 + c5 - c1 - c2,
					  c3 + c6 - c2 - c5, c5 + c6 - c2 - c3,
					  c5 + c8 - c4 - c7, c7 + c8 - c4 - c5,
					  c6 + c9 - c5 - c8, c8 + c9 - c5 - c6,
					  sLOut_x, sLOut_y);
}
