
#pragma version(1)
#pragma rs java_package_name(com.picsart.effects.rs)

#include "rs_utils.rsh"

static uchar lut[256];

void set_params_sketcher_1(rs_allocation diff, int lower_intensity, int upper_intensity) {
    const int W = rsAllocationGetDimX(diff);
    const int H = rsAllocationGetDimY(diff);

    int min = 255;
    int max = 0;
    for (int y = 0; y < H; ++y)
    {
    	for (int x = 0; x < W; ++x)
    	{
    		const uchar color = getValUChar(diff, y, x);
    		min = (color < min) ? color : min;
    		max = (color > max) ? color : max;
    	}
    }

    // Apply normalize and correction.
    float k = 255.f / (upper_intensity - lower_intensity);
    float b = -255.f * lower_intensity / (upper_intensity - lower_intensity);
    int mm = max - min;
    uchar cur_lut;

    for (int x = 0; x < 256; ++x)
    {
    	cur_lut = SATURATE_CAST_TO_UCHAR( (x - min) * 255 / mm );
    	lut[x] = SATURATE_CAST_TO_UCHAR(k * cur_lut + b);
    }
}

void root(uchar *v_out, uint32_t x, uint32_t y) {
	*v_out = lut[*v_out];
}
