
#pragma version(1)
#pragma rs java_package_name(com.picsart.effects.rs)

#include "rs_utils.rsh"

static rs_allocation dif, gray_img;
static uchar4 ct, cb;
static uchar lut_for_gray[256];
static int c1, c2;

void set_params_sketcher_3(rs_allocation diff, rs_allocation gray_alloc, int color_bottom, int color_top) {
    cb.r = (color_bottom >> 16) & 255;
    cb.g = (color_bottom >> 8) & 255;
    cb.b = (color_bottom) & 255;

    ct.r = (color_top >> 16) & 255;
    ct.g = (color_top >> 8) & 255;
    ct.b = (color_top) & 255;

    c1 = color_bottom;
    c2 = color_top;

    dif = diff;
    gray_img = gray_alloc;

    for (int i = 0; i < 256; i++)
    	lut_for_gray[i] = SATURATE_CAST_TO_UCHAR(floor((float)((i - 4) / 24.f + 0.5f)) * 24 + 4);
}

void root(uchar4 *v_out, uint32_t x, uint32_t y) {
	const int igray = lut_for_gray[getValUChar(gray_img, y, x)];
	const int idiff = getValUChar(dif, y, x);
	if ( (c1 == 0) && (c2 == 0xFFFFFF) )
		*v_out = (uchar4) {	idiff * igray / 255,
							idiff * igray / 255,
							idiff * igray / 255,
							255 };
	else
		*v_out = (uchar4) { idiff * (igray * ct.r + (255-igray)*cb.r) / 255 / 255,
							idiff * (igray * ct.g + (255-igray)*cb.g) / 255 / 255,
							idiff * (igray * ct.b + (255-igray)*cb.b) / 255 / 255,
							255 };
}
