
#pragma version(1)
#pragma rs java_package_name(com.picsart.effects.rs)

#include "rs_utils.rsh"

static int x0, y0;
static float ss2;
static uchar lut[256];

void set_params_stenciler_1(int width, int height, float fade_borders, int intensity_shift, float gamma) {
    const float s = max(width, height) * fade_borders;
    ss2 = s*s*2;
    x0 = width / 2;
    y0 = height / 2;

    for (int i = 0; i < intensity_shift; i++)
        lut[i] = 0;
    const float coef = pow(256.f - intensity_shift, 1.f - gamma);
    for (int i = intensity_shift; i < 256; i++)
        lut[i] = SATURATE_CAST_TO_UCHAR(pow(i - intensity_shift, gamma) * coef);
}

void root(const uchar4 *v_in, uchar *v_out, uint32_t x, uint32_t y) {
    const int dx = x - x0;
    const int dy = y - y0;
    const float c = exp(-(dx*dx + dy*dy)/ss2);
    const uchar gp = 255 - c * v_in->g;
    *v_out = lut[gp];
}
