
#pragma version(1)
#pragma rs java_package_name(com.picsart.effects.rs)

#include "rs_utils.rsh"

static float mTi, kTi, mTe, kTe;
static const float scale = 1.f / 255.f;

void set_params_tint_and_temperature(float tint, float temperature) {
    mTi = tint > 0 ? -1.f : 1.f;
    kTi = fabs(tint);
    mTe = temperature > 0 ? -1.f : 1.f;
    kTe = fabs(temperature);
}

void root(const uchar4 *v_in, uchar4 *v_out, uint32_t x, uint32_t y) {
    uchar4 val = *v_in;

    const int Y = DESCALE(val.r * RGB2YCC_C0  +  val.g * RGB2YCC_C1  +  val.b * RGB2YCC_C2, YCC_SHIFT);
    int Cr = DESCALE((val.r - Y) * RGB2YCC_C3 + YCC_DELTA, YCC_SHIFT);
    int Cb = DESCALE((val.b - Y) * RGB2YCC_C4 + YCC_DELTA, YCC_SHIFT);

    float r = Cr * scale - 0.5f;
    float b = Cb * scale - 0.5f;

    float ti = b + r;
    float te = b - r;

    ti += (mTi - ti) * kTi;
    te += (mTe - te) * kTe;

    b = (ti + te) * 0.5f;
    r = ti - b;

    Cr = clamp(r + 0.5f, 0.f, 1.f) * 255.f;
    Cb = clamp(b + 0.5f, 0.f, 1.f) * 255.f;

    val.r = SATURATE_CAST_TO_UCHAR(Y + DESCALE((Cr - 128) * YCC2RGB_C0, YCC_SHIFT));
    val.g = SATURATE_CAST_TO_UCHAR(Y + DESCALE((Cr - 128) * YCC2RGB_C1 + (Cb - 128) * YCC2RGB_C2, YCC_SHIFT));
    val.b = SATURATE_CAST_TO_UCHAR(Y + DESCALE((Cb - 128) * YCC2RGB_C3, YCC_SHIFT));

    *v_out = val;
}
