
#pragma version(1)
#pragma rs java_package_name(com.picsart.effects.rs)

#include "rs_utils.rsh"

static uchar red_lut[256];
static uchar green_lut[256];
static uchar blue_lut[256];

void set_params_tranquil(int contrast, int brightness) {
    contrast = min(100, max(contrast, 0));
    brightness = min(100, max(brightness, 0));

    float koeffs[3][3] = { {-0.00044460205,    0.65847158, 66},
                           {-0.0019713987,     1.408589,   0},
                           {-0.0049211006,     2.7067721,  -111.83952} };

    for (int i = 0; i < 256; ++i) {
        int r = koeffs[2][0] * i * i + koeffs[2][1] * i + koeffs[2][2];
        int g = koeffs[1][0] * i * i + koeffs[1][1] * i + koeffs[1][2];
        int b = koeffs[0][0] * i * i + koeffs[0][1] * i + koeffs[0][2];
        float rv = ((r - 128) * contrast / 50.f + 128) * brightness / 50.f;
        float gv = ((g - 128) * contrast / 50.f + 128) * brightness / 50.f;
        float bv = ((b - 128) * contrast / 50.f + 128) * brightness / 50.f;
        red_lut[i] = (rv < 0) ? 0 : ((rv > 255) ? 255 : rv);
        green_lut[i] = (gv < 0) ? 0 : ((gv > 255) ? 255 : gv);
        blue_lut[i] = (bv < 0) ? 0 : ((bv > 255) ? 255 : bv);
    }
}

void root(const uchar4 *v_in, uchar4 *v_out) {
    *v_out = (uchar4){red_lut[v_in->r], green_lut[v_in->g], blue_lut[v_in->b], 255};
}

