#pragma version(1)
#pragma rs java_package_name(com.picsart.effects.rs)

#include "rs_utils.rsh"

static const int UNITEDCOLORS_MODE_STD   = 0;
static const int UNITEDCOLORS_MODE_RED   = 1;
static const int UNITEDCOLORS_MODE_GREEN = 2;
static const int UNITEDCOLORS_MODE_BLUE  = 3;

static int r1, g1, b1, r2, g2, b2;
static int my_mode;

void set_params_unitedcolors(int mode, int color1, int color2) {
	my_mode = mode;

    r1 = (color1 >> 16) & 255;
    g1 = (color1 >>  8) & 255;
    b1 = (color1     ) & 255;

    r2 = (color2 >> 16) & 255;
    g2 = (color2 >>  8) & 255;
    b2 = (color2      ) & 255;
}

void root(const uchar4 *v_in, uchar4 *v_out) {

    uchar v, iv;
    switch (my_mode) {
        case UNITEDCOLORS_MODE_RED:
                v  = v_in->r;
            break;
        case UNITEDCOLORS_MODE_GREEN:
            v  = v_in->g;
            break;

        case UNITEDCOLORS_MODE_BLUE:
            v  = v_in->b;
            break;

        case UNITEDCOLORS_MODE_STD:
        default:
                v  = v_in->b / 10 + v_in->g / 2 + v_in->r / 3;
            break;
    }

	iv = 255 - v;
    *v_out = (uchar4) { (r1 * v + r2 * iv) / 255,
                        (g1 * v + g2 * iv) / 255,
						(b1 * v + b2 * iv) / 255,
						255};
}



