#pragma version(1)
#pragma rs java_package_name(com.picsart.effects.rs)

#include "rs_utils.rsh"

static rs_allocation integral;
static int W, H;
static int iblur;

void set_params_utils_box_convolve_gray(rs_allocation source, rs_allocation temp, int blur) {
    W = rsAllocationGetDimX(source);
    H = rsAllocationGetDimY(source);

    integral = temp;

    iblur = blur / 2;
    *getInt(integral, 0, 0) = getValUChar(source, 0, 0);

    const uchar *sp = getUChar(source, 0, 1); // Source point
    int *lip = getInt(integral, 0, 0);        // Left integral point
    int *cip = getInt(integral, 0, 1);        // Current integral point
    for(int x = 1; x < W; ++x, sp++, lip++, cip++) {
        *cip = *sp + *lip;
    }

    sp = getUChar(source, 1, 0);
    int *tip = getInt(integral, 0, 0); // Top integral point
    cip      = getInt(integral, 1, 0);
    for(int y = 1; y < H; ++y, sp += W, tip += W, cip += W) {
        *cip = *sp + *tip;
    }

    int *dip; // Diagonal (top-left) integral point
    for(int y = 1; y < H; ++y) {
        sp = getUChar(source, y, 1);
        tip = getInt(integral, y - 1, 1);
        dip = getInt(integral, y - 1, 0);
        lip = getInt(integral, y,     0);
        cip = getInt(integral, y,     1);
        for(int x = 1; x < W; ++x, sp++, tip++, dip++, lip++, cip++) {
            *cip = *sp + *lip + *tip - *dip;

        }
    }
}

void root(uchar *v_out, uint32_t x, uint32_t y) {
    const int x0 = max(0, (int)x - iblur);
    const int x1 = min(W - 1, (int)x + iblur);
    const int y0 = max(0, (int)y - iblur);
    const int y1 = min(H - 1, (int)y + iblur);

    const int S = (x1 - x0 + 1) * (y1 - y0 + 1);

    const int int_a = getValInt(integral, y1, x1);
    const int int_b = x0 == 0 ? 0 : getValInt(integral, y1, x0 - 1);
    const int int_c = y0 == 0 ? 0 : getValInt(integral, y0 - 1, x1);
    const int int_d = (x0 == 0 || y0 == 0) ? 0 : getValInt(integral, y0 - 1, x0 - 1);

    *v_out = (int_a + int_d + S / 2 - int_b - int_c) / S;
}
