
#pragma version(1)
#pragma rs java_package_name(com.picsart.effects.rs)

#include "rs_utils.rsh"

static const float rwgt = 0.3086f;
static const float gwgt = 0.6094f;
static const float bwgt = 0.0820f;

static int m00, m01, m02, m10, m11, m12, m20, m21, m22;

void set_params_utils_correct_saturation(float saturation) {
    saturation = max(0.f, saturation);
    const float oms = 1.f - saturation;

    m00 = (oms * rwgt + saturation) * 255;
    m01 = (oms * rwgt) * 255;
    m02 = (oms * rwgt) * 255;
    m10 = (oms * gwgt) * 255;
    m11 = (oms * gwgt + saturation) * 255;
    m12 = (oms * gwgt) * 255;
    m20 = (oms * bwgt) * 255;
    m21 = (oms * bwgt) * 255;
    m22 = (oms * bwgt + saturation) * 255;
}

void root(const uchar4 *v_in, uchar4 *v_out) {
    uchar r = v_in->r;
    uchar g = v_in->g;
    uchar b = v_in->b;
    *v_out = (uchar4){  SATURATE_CAST_TO_UCHAR((r * m00 + g * m10 + b * m20) / 255),
                        SATURATE_CAST_TO_UCHAR((r * m01 + g * m11 + b * m21) / 255),
                        SATURATE_CAST_TO_UCHAR((r * m02 + g * m12 + b * m22) / 255),
                        255  };
}
