#pragma version(1)
#pragma rs java_package_name(com.picsart.effects.rs)

static rs_allocation integral;

static inline int3* getInt3(rs_allocation allocation, uint32_t x, uint32_t y)
{
    return (int3*)rsGetElementAt(allocation, x, y);
}

static inline uint3* getUInt3(rs_allocation allocation, uint32_t x, uint32_t y)
{
    return (uint3*)rsGetElementAt(allocation, x, y);
}

void set_params_utils_image_integral(rs_allocation source, rs_allocation integ)
{
	int W = rsAllocationGetDimX(source);
    int H = rsAllocationGetDimY(source);

    integral = integ;

    const int3 *sp = getInt3(source, 0, 0); // Source point
    uint3 *cip = getUInt3(integral, 0, 0);        // Current integral point
    cip->r = sp->r;
    cip->g = sp->g;
    cip->b = sp->b;

    sp = getInt3(source, 0, 1); // Source point
    uint3 *lip = getUInt3(integral, 0, 0); // Left integral point
    cip        = getUInt3(integral, 1, 0); // Current integral point
    for(int x = 1; x < W; ++x, sp++, lip++, cip++)
    {
        cip->r = sp->r + lip->r;
        cip->g = sp->g + lip->g;
        cip->b = sp->b + lip->b;
    }

    sp = getInt3(source, 0, 1);
    uint3 *tip = getUInt3(integral, 0, 0); // Top integral point
    cip        = getUInt3(integral, 0, 1);
    for(int y = 1; y < H; ++y, sp += W, tip += W, cip += W)
    {
        cip->r = sp->r + tip->r;
        cip->g = sp->g + tip->g;
        cip->b = sp->b + tip->b;
    }

    uint3 *dip; // Diagonal (top-left) integral point
    for(int y = 1; y < H; ++y)
    {
        sp = getInt3(source, 1, y);
        tip = getUInt3(integral, 1, y - 1);
        dip = getUInt3(integral, 0, y - 1);
        lip = getUInt3(integral, 0,     y);
        cip = getUInt3(integral, 1,     y);
        for(int x = 1; x < W; ++x, sp++, tip++, dip++, lip++, cip++)
        {
            cip->r = sp->r + lip->r + tip->r - dip->r;
            cip->g = sp->g + lip->g + tip->g - dip->g;
            cip->b = sp->b + lip->b + tip->b - dip->b;
        }
    }
}

