#pragma version(1)
#pragma rs java_package_name(com.picsart.effects.rs)

#include "rs_utils.rsh"

static rs_allocation integral;
static int W, H;
static int iblur1, iblur2;

void set_params_utils_diff_blur_gray(rs_allocation source, rs_allocation temp, int blur1, int blur2) {
    W = rsAllocationGetDimX(source);
    H = rsAllocationGetDimY(source);

    integral = temp;

    iblur1 = blur1 / 2;
    iblur2 = blur2 / 2;
    *getInt(integral, 0, 0) = getValUChar(source, 0, 0);

    const uchar *sp = getUChar(source, 0, 1); // Source point
    int *lip = getInt(integral, 0, 0);        // Left integral point
    int *cip = getInt(integral, 0, 1);        // Current integral point
    for(int x = 1; x < W; ++x, sp++, lip++, cip++) {
        *cip = *sp + *lip;
    }

    sp = getUChar(source, 1, 0);
    int *tip = getInt(integral, 0, 0); // Top integral point
    cip      = getInt(integral, 1, 0);
    for(int y = 1; y < H; ++y, sp += W, tip += W, cip += W) {
        *cip = *sp + *tip;
    }

    int *dip; // Diagonal (top-left) integral point
    for(int y = 1; y < H; ++y) {
        sp = getUChar(source, y, 1);
        tip = getInt(integral, y - 1, 1);
        dip = getInt(integral, y - 1, 0);
        lip = getInt(integral, y,     0);
        cip = getInt(integral, y,     1);
        for(int x = 1; x < W; ++x, sp++, tip++, dip++, lip++, cip++) {
            *cip = *sp + *lip + *tip - *dip;

        }
    }
}

void root(uchar *v_out, uint32_t x, uint32_t y) {
	int x0 = max(0, (int)x - iblur1);
	int x1 = min(W - 1, (int)x + iblur1);
	int y0 = max(0, (int)y - iblur1);
	int y1 = min(H - 1, (int)y + iblur1);

    int S = (x1 - x0 + 1) * (y1 - y0 + 1);

    int int_a = getValInt(integral, y1, x1);
    int int_b = x0 == 0 ? 0 : getValInt(integral, y1, x0 - 1);
    int int_c = y0 == 0 ? 0 : getValInt(integral, y0 - 1, x1);
    int int_d = (x0 == 0 || y0 == 0) ? 0 : getValInt(integral, y0 - 1, x0 - 1);

	const int res1 = (int_a + int_d + S / 2 - int_b - int_c) / S;

	x0 = max(0, (int)x - iblur2);
	x1 = min(W - 1, (int)x + iblur2);
	y0 = max(0, (int)y - iblur2);
	y1 = min(H - 1, (int)y + iblur2);

    S = (x1 - x0 + 1) * (y1 - y0 + 1);

    int_a = getValInt(integral, y1, x1);
    int_b = x0 == 0 ? 0 : getValInt(integral, y1, x0 - 1);
    int_c = y0 == 0 ? 0 : getValInt(integral, y0 - 1, x1);
    int_d = (x0 == 0 || y0 == 0) ? 0 : getValInt(integral, y0 - 1, x0 - 1);

	const int res2 = (int_a + int_d + S / 2 - int_b - int_c) / S;

	*v_out =  SATURATE_CAST_TO_UCHAR(255 + res2 - res1);
}
