
#pragma version(1)
#pragma rs java_package_name(com.picsart.effects.rs)

#include "rs_utils.rsh"

static int k0;
static int k1;
static int k1k0;
static int max_diff;
static int cx;
static int cy;

void set_params_utils_draw_circular_gradient(int w, int h, int max_difference, float vignette) {
    cx = w / 2;
    cy = h / 2;
    float whK = max(w, h) * sqrt(2.f) * vignette;
    k0 = whK * 0.2f;
    k1 = whK * 0.45f;
    k1k0 = k1 - k0;
    max_diff = max_difference;
}

void root(const uchar4 *v_in, uchar4 *v_out, uint32_t x, uint32_t y) {
    const int dx = x - cx;
    const int dy = y - cy;
    float k = sqrt((float)(dx*dx + dy*dy));
    k = k <= k0 ? 0.f : k >= k1 ? 1.f : ((k - k0) / k1k0);
// OPTIMISATION
//  float k = dx*dx + dy*dy;
//  k = k <= k0*k0 ? 0.f : k >= k1*k1 ? 1.f : ((k - k0*k0) / (k1*k1 - k0*k0));

    int diff = max_diff * k;

    v_out->r = SATURATE_CAST_TO_UCHAR(v_in->r + diff);
    v_out->g = SATURATE_CAST_TO_UCHAR(v_in->g + diff);
    v_out->b = SATURATE_CAST_TO_UCHAR(v_in->b + diff);
}
