
#pragma version(1)
#pragma rs java_package_name(com.picsart.effects.rs)

#include "rs_utils.rsh"

static uchar pst_black_and_white_pixel(
    const uchar R,
    const uchar G,
    const uchar B,
    const int * const rygcbm_coeffs)
{
    uchar minC, midC, maxC, main_idx, middle_idx;

    if (R > G) {
        if (R > B) {
            if (G > B) { // R > G > B
                maxC = R;
                midC = G;
                minC = B;
                main_idx = 0;
                middle_idx = 1;
            }
            else { // R > B > G
                maxC = R;
                midC = B;
                minC = G;
                main_idx = 0;
                middle_idx = 5;
            }
        }
        else { // B > R > G
            maxC = B;
            midC = R;
            minC = G;
            main_idx = 4;
            middle_idx = 5;
        }
    }
    else if (G > B) {
        if (R > B) { // G > R > B
            maxC = G;
            midC = R;
            minC = B;
            main_idx = 2;
            middle_idx = 1;
        }
        else { // G > B > R
            maxC = G;
            midC = B;
            minC = R;
            main_idx = 2;
            middle_idx = 3;
        }
    }
    else { // B > G > R
        maxC = B;
        midC = G;
        minC = R;
        main_idx = 4;
        middle_idx = 3;
    }

    int gray = minC * 100;
    if (maxC != minC)
        gray += (rygcbm_coeffs[main_idx] * (maxC - midC) + rygcbm_coeffs[middle_idx] * (midC - minC));

    return SATURATE_CAST_TO_UCHAR(gray / 100);
}
