
#pragma version(1)
#pragma rs java_package_name(com.picsart.effects.rs)

#include "rs_utils.rsh"

static int rr;
static int rg;
static int rb;
static int gr;
static int gg;
static int gb;
static int br;
static int bg;
static int bb;
static bool pl;

void set_params_utils_pst_photo_filter(
    float rr_, float rg_, float rb_,
    float gr_, float gg_, float gb_,
    float br_, float bg_, float bb_,
    bool preserveLuminosity)
{
    rr = rr_ * 1000;
    rg = rg_ * 1000;
    rb = rb_ * 1000;
    gr = gr_ * 1000;
    gg = gg_ * 1000;
    gb = gb_ * 1000;
    br = br_ * 1000;
    bg = bg_ * 1000;
    bb = bb_ * 1000;
    pl = preserveLuminosity;
}

void root(const uchar4 *v_in, uchar4 *v_out) {
    uchar r = v_in->r;
    uchar g = v_in->g;
    uchar b = v_in->b;

    int Y = 0;
    if (pl)
        Y = DESCALE(r * RGB2YCC_C0  +  g * RGB2YCC_C1  +  b * RGB2YCC_C2, YCC_SHIFT);

    r = SATURATE_CAST_TO_UCHAR((rr * r + rg * g + rb * b) / 1000);
    g = SATURATE_CAST_TO_UCHAR((gr * r + gg * g + gb * b) / 1000);
    b = SATURATE_CAST_TO_UCHAR((br * r + bg * g + bb * b) / 1000);

    if (pl) {
        const int cY = DESCALE(r * RGB2YCC_C0  +  g * RGB2YCC_C1  +  b * RGB2YCC_C2, YCC_SHIFT);
        const int Cr = DESCALE((r - cY) * RGB2YCC_C3 + YCC_DELTA, YCC_SHIFT);
        const int Cb = DESCALE((b - cY) * RGB2YCC_C4 + YCC_DELTA, YCC_SHIFT);
        r = SATURATE_CAST_TO_UCHAR(Y + DESCALE((Cr - 128) * YCC2RGB_C0, YCC_SHIFT));
        g = SATURATE_CAST_TO_UCHAR(Y + DESCALE((Cr - 128) * YCC2RGB_C1 + (Cb - 128) * YCC2RGB_C2, YCC_SHIFT));
        b = SATURATE_CAST_TO_UCHAR(Y + DESCALE((Cb - 128) * YCC2RGB_C3, YCC_SHIFT));
    }

    *v_out = (uchar4){r, g, b, 255};
}
