
#pragma version(1)
#pragma rs java_package_name(com.picsart.effects.rs)

#include "rs_utils.rsh"

static void pst_selective_color_get_metric(const uchar4 * sp, uchar * metric) {
    memset(metric, 0, 9);

    uchar R = sp->r;
    uchar G = sp->g;
    uchar B = sp->b;

    uchar minC, midC, maxC, main_idx, middle_idx;

    if (R > G) {
        if (R > B) {
            if (G > B) { // R > G > B
                maxC = R;
                midC = G;
                minC = B;
                main_idx = 0;
                middle_idx = 1;
            }
            else { // R > B > G
                maxC = R;
                midC = B;
                minC = G;
                main_idx = 0;
                middle_idx = 5;
            }
        }
        else { // B > R > G
            maxC = B;
            midC = R;
            minC = G;
            main_idx = 4;
            middle_idx = 5;
        }
    }
    else if (G > B) {
        if (R > B) { // G > R > B
            maxC = G;
            midC = R;
            minC = B;
            main_idx = 2;
            middle_idx = 1;
        }
        else { // G > B > R
            maxC = G;
            midC = B;
            minC = R;
            main_idx = 2;
            middle_idx = 3;
        }
    }
    else { // B > G > R
        maxC = B;
        midC = G;
        minC = R;
        main_idx = 4;
        middle_idx = 3;
    }

    // Calculate color components
    const uchar colors = maxC - minC;
    if (colors > 0) {
        metric[main_idx]   = maxC - midC;
        metric[middle_idx] = midC - minC;
    }

    // Calculate gray components
    const uchar bgw = 255 - colors;
    if (bgw > 0) {
        if (minC >= 128) {
            const uchar gray = bgw * (255 - minC) / 127;
            metric[6] = bgw - gray;
            metric[7] = gray;
        }
        else {
            const uchar gray = bgw * minC / 127;
            metric[7] = gray;
            metric[8] = bgw - gray;
        }
    }
}
