
#pragma version(1)
#pragma rs java_package_name(com.picsart.effects.rs)

#include "rs_utils_pst_selective_color.rsh"

static int coeffs_data[9][3];
static int * coeffs[9];

static void set_coeffs(int i, int c, int m, int y, int k) {
    if (c || m || y || k) {
        int* cfs = coeffs_data[i];
        cfs[0] = c + k + c * k / 100;
        cfs[1] = m + k + m * k / 100;
        cfs[2] = y + k + y * k / 100;

        coeffs[i] = cfs;
    }
    else
        coeffs[i] = NULL;
}

void set_params_utils_pst_selective_color_relative(
    int rC, int rM, int rY, int rK,
    int yC, int yM, int yY, int yK,
    int gC, int gM, int gY, int gK,
    int cC, int cM, int cY, int cK,
    int bC, int bM, int bY, int bK,
    int mC, int mM, int mY, int mK,
    int wC, int wM, int wY, int wK,
    int nC, int nM, int nY, int nK,
    int kC, int kM, int kY, int kK)
{
    set_coeffs(0, rC, rM, rY, rK);
    set_coeffs(1, yC, yM, yY, yK);
    set_coeffs(2, gC, gM, gY, gK);
    set_coeffs(3, cC, cM, cY, cK);
    set_coeffs(4, bC, bM, bY, bK);
    set_coeffs(5, mC, mM, mY, mK);
    set_coeffs(6, wC, wM, wY, wK);
    set_coeffs(7, nC, nM, nY, nK);
    set_coeffs(8, kC, kM, kY, kK);
}

void root(const uchar4 *v_in, uchar4 *v_out) {
    const int sR = v_in->r;
    const int sG = v_in->g;
    const int sB = v_in->b;

    const int sC = 255 - sR;
    const int sM = 255 - sG;
    const int sY = 255 - sB;

    int rR = 0;
    int rG = 0;
    int rB = 0;

    uchar metric[9];
    pst_selective_color_get_metric(v_in, metric);

    int other = 0;
    for (int i = 0; i < 9; i++) {
        const int comp = metric[i];
        if (comp > 0) {
            const int* cfs = coeffs[i];
            if (cfs != NULL) {
                rR += comp * SATURATE_CAST_TO_UCHAR(sR - sC * cfs[0] / 100);
                rG += comp * SATURATE_CAST_TO_UCHAR(sG - sM * cfs[1] / 100);
                rB += comp * SATURATE_CAST_TO_UCHAR(sB - sY * cfs[2] / 100);
            }
            else
                other += comp;
        }
    }

    *v_out = (uchar4){  (rR + other * sR) / 255,
                        (rG + other * sG) / 255,
                        (rB + other * sB) / 255,
                        255  };
}
