
#pragma version(1)
#pragma rs java_package_name(com.picsart.effects.rs)

#include "rs_utils.rsh"

static rs_allocation source, blured;

static short lut[256];

void set_params_utils_pst_shadows_and_highlights(
    rs_allocation source_alloc, rs_allocation blured_alloc,
    const float s_a, const float s_b,
    const float h_a, const float h_b)
{
    source = source_alloc;
    blured = blured_alloc;

    for (int i = 0; i < 256; ++i) {
        const float x = i / 255.f;
        const float omx = 1.f - x;
        const float y = (omx - pow(omx, s_a)) * pow(omx, s_b) - (x - pow(x, h_a)) * pow(x, h_b);
        lut[i] = y * 255;
    }
}

void root(uchar4 *v_out, uint32_t x, uint32_t y) {
    const uchar4 sp = getValUChar4(source, y, x);
    const uchar4 bp = getValUChar4(blured, y, x);

    const uchar V = max(bp.r, max(bp.g, bp.b));
    const uchar Y = DESCALE(bp.r * RGB2YCC_C0  +  bp.g * RGB2YCC_C1  +  bp.b * RGB2YCC_C2, YCC_SHIFT);
    const short delta = lut[V] * Y / max((uchar)1, V);

    *v_out = (uchar4){  SATURATE_CAST_TO_UCHAR(sp.r + delta),
                        SATURATE_CAST_TO_UCHAR(sp.g + delta),
                        SATURATE_CAST_TO_UCHAR(sp.b + delta),
                        255  };
}
