
#pragma version(1)
#pragma rs java_package_name(com.picsart.effects.rs)

#include "rs_utils.rsh"

static rs_allocation src;
static int kS2, offset, max_coord;
static bool vert;

void set_params_utils_tent_convolve_gray_float(rs_allocation source, int kernel_size, bool vertical) {
    const int W = rsAllocationGetDimX(source);
    const int H = rsAllocationGetDimY(source);

    src = source;

    const int kS = kernel_size;
    kS2 = kS / 2 + 1;

    vert = vertical;
    offset = vert ? W : 1;
    max_coord = vert ? H : W;
}

void root(float *v_out, uint32_t x, uint32_t y) {
    const int coord = vert ? y : x;
    const int c_min = max(0, coord - (kS2 - 1));
    const int c_max = min(max_coord - 1, coord + (kS2 - 1));
    const int k_beg = kS2 - (coord - c_min);
    const int k_end = kS2 - (c_max - coord);

    float summ = 0;
    int ksumm = 0;

    const float *cp = getFloat(src, y, x);
    const float *p = cp;

    for (int k = kS2; k >= k_beg; k--, p -= offset) {
        summ += (*p) * k;
        ksumm += k;
    }
    p = cp + offset;
    for (int k = kS2 - 1; k >= k_end; k--, p += offset) {
        summ += (*p) * k;
        ksumm += k;
    }
    summ /= ksumm;
    *v_out = summ;
}
