
#pragma version(1)
#pragma rs java_package_name(com.picsart.effects.rs)

#include "rs_utils.rsh"

static const VIGNETTE_SQRT = 1;
static const VIGNETTE_LINEAR = 2;
static const VIGNETTE_SQUARE = 3;
static const VIGNETTE_CUBE = 4;
static const VIGNETTE_SIN = 5;

static int field_size, w, h;
static uchar3 v_color;

static uchar get_vignette_param_sqrt(int r, int R)
{
	if(r > R)
		r = R;
	if(r < 0)
		r = 0;
	return pow((float)r / R, 0.5f) * 255.f;
}

static uchar get_vignette_param_linear(int r, int R)
{
	if(r > R)
		r = R;
	if(r < 0)
		r = 0;
	return (float)r / R * 255.f;
}

static uchar get_vignette_param_square(int r, int R)
{
	if(r > R)
		r = R;
	if(r < 0)
		r = 0;
	return pow((float)r / R, 2.f) * 255.f;
}

static uchar get_vignette_param_cube(int r, int R)
{
	if(r > R)
		r = R;
	if(r < 0)
		r = 0;
	return pow((float)r / R, 3.f) * 255.f;
}

static uchar get_vignette_param_sin(int r, int R)
{
	if(r > R)
		r = R;
	if(r < 0)
		r = 0;
	return sin((float)r / R * 3.14f / 2.f) * 255.f;
}

//static uchar (*get_vignette_param) (int, int);
static int _algorithm;

void set_params_vignette(int width, int height, int color, int radius, int algorithm) {
	field_size = min(width, height) / 200.f * radius;
	v_color = (uchar3) {get_red(color), get_green(color), get_blue(color)};

	w = width;
	h = height;
	/*
	switch(algorithm)
	{
		case VIGNETTE_SQRT:
			get_vignette_param = get_vignette_param_sqrt;
			break;
		case VIGNETTE_LINEAR:
			get_vignette_param = get_vignette_param_linear;
			break;
		case VIGNETTE_SQUARE:
			get_vignette_param = get_vignette_param_square;
			break;
		case VIGNETTE_CUBE:
			get_vignette_param = get_vignette_param_cube;
			break;
		case VIGNETTE_SIN:
			get_vignette_param = get_vignette_param_sin;
			break;
		default:
			get_vignette_param = get_vignette_param_square;
	}
	*/
    _algorithm = algorithm;
}

void root(const uchar4 *v_in, uchar4 *v_out, uint32_t x, uint32_t y) {
    uchar a;

    /*
    //corners
    if (((x < field_size) && (y < field_size)) ||
            ((x < field_size) && (h - y - 1 < field_size)) ||
            ((w - x - 1 < field_size) && (y < field_size)) ||
            ((w - x - 1 < field_size) && (h - y - 1 < field_size)))
        a = get_vignette_param(field_size - sqrt(pow((float)(field_size - min(x, w - x - 1)), 2.f) +
            pow((float)(field_size - min(y, h - y - 1)), 2.f)), field_size);
    //left and right
    else if ((y >= field_size) && (y < h - field_size) && ((x < field_size) || (w - x - 1 < field_size)))
        a = get_vignette_param(min(x, w - x -1), field_size);
    //top and bottom
    else if ((x >= field_size) && (x < w - field_size) && ((y < field_size) || (h - y - 1 < field_size)))
        a = get_vignette_param(min(y, h - y - 1), field_size);
    else
        a = 255;
    */
    
    switch(_algorithm)
	{
		case VIGNETTE_SQRT:
		{
		    //corners
			if (((x < field_size) && (y < field_size)) ||
			        ((x < field_size) && (h - y - 1 < field_size)) ||
			        ((w - x - 1 < field_size) && (y < field_size)) ||
			        ((w - x - 1 < field_size) && (h - y - 1 < field_size)))
			    a = get_vignette_param_sqrt(field_size - sqrt(pow((float)(field_size - min(x, w - x - 1)), 2.f) +
			        pow((float)(field_size - min(y, h - y - 1)), 2.f)), field_size);
            //left and right
            else if ((y >= field_size) && (y < h - field_size) && ((x < field_size) || (w - x - 1 < field_size)))
                a = get_vignette_param_sqrt(min(x, w - x -1), field_size);
            //top and bottom
            else if ((x >= field_size) && (x < w - field_size) && ((y < field_size) || (h - y - 1 < field_size)))
                a = get_vignette_param_sqrt(min(y, h - y - 1), field_size);
            else
                a = 255;
		}
			break;
			
		case VIGNETTE_LINEAR:
		{
		    //corners
			if (((x < field_size) && (y < field_size)) ||
			        ((x < field_size) && (h - y - 1 < field_size)) ||
			        ((w - x - 1 < field_size) && (y < field_size)) ||
			        ((w - x - 1 < field_size) && (h - y - 1 < field_size)))
			    a = get_vignette_param_linear(field_size - sqrt(pow((float)(field_size - min(x, w - x - 1)), 2.f) +
			        pow((float)(field_size - min(y, h - y - 1)), 2.f)), field_size);
            //left and right
            else if ((y >= field_size) && (y < h - field_size) && ((x < field_size) || (w - x - 1 < field_size)))
                a = get_vignette_param_linear(min(x, w - x -1), field_size);
            //top and bottom
            else if ((x >= field_size) && (x < w - field_size) && ((y < field_size) || (h - y - 1 < field_size)))
                a = get_vignette_param_linear(min(y, h - y - 1), field_size);
            else
                a = 255;
		}
			break;

		default:
		case VIGNETTE_SQUARE:
		{
		    //corners
			if (((x < field_size) && (y < field_size)) ||
			        ((x < field_size) && (h - y - 1 < field_size)) ||
			        ((w - x - 1 < field_size) && (y < field_size)) ||
			        ((w - x - 1 < field_size) && (h - y - 1 < field_size)))
			    a = get_vignette_param_square(field_size - sqrt(pow((float)(field_size - min(x, w - x - 1)), 2.f) +
			        pow((float)(field_size - min(y, h - y - 1)), 2.f)), field_size);
            //left and right
            else if ((y >= field_size) && (y < h - field_size) && ((x < field_size) || (w - x - 1 < field_size)))
                a = get_vignette_param_square(min(x, w - x -1), field_size);
            //top and bottom
            else if ((x >= field_size) && (x < w - field_size) && ((y < field_size) || (h - y - 1 < field_size)))
                a = get_vignette_param_square(min(y, h - y - 1), field_size);
            else
                a = 255;
		}
			break;

		case VIGNETTE_CUBE:
		{
		    //corners
			if (((x < field_size) && (y < field_size)) ||
			        ((x < field_size) && (h - y - 1 < field_size)) ||
			        ((w - x - 1 < field_size) && (y < field_size)) ||
			        ((w - x - 1 < field_size) && (h - y - 1 < field_size)))
			    a = get_vignette_param_cube(field_size - sqrt(pow((float)(field_size - min(x, w - x - 1)), 2.f) +
			        pow((float)(field_size - min(y, h - y - 1)), 2.f)), field_size);
            //left and right
            else if ((y >= field_size) && (y < h - field_size) && ((x < field_size) || (w - x - 1 < field_size)))
                a = get_vignette_param_cube(min(x, w - x -1), field_size);
            //top and bottom
            else if ((x >= field_size) && (x < w - field_size) && ((y < field_size) || (h - y - 1 < field_size)))
                a = get_vignette_param_cube(min(y, h - y - 1), field_size);
            else
                a = 255;
		}
			break;

		case VIGNETTE_SIN:
		{
		    //corners
			if (((x < field_size) && (y < field_size)) ||
			        ((x < field_size) && (h - y - 1 < field_size)) ||
			        ((w - x - 1 < field_size) && (y < field_size)) ||
			        ((w - x - 1 < field_size) && (h - y - 1 < field_size)))
			    a = get_vignette_param_sin(field_size - sqrt(pow((float)(field_size - min(x, w - x - 1)), 2.f) +
			        pow((float)(field_size - min(y, h - y - 1)), 2.f)), field_size);
            //left and right
            else if ((y >= field_size) && (y < h - field_size) && ((x < field_size) || (w - x - 1 < field_size)))
                a = get_vignette_param_sin(min(x, w - x -1), field_size);
            //top and bottom
            else if ((x >= field_size) && (x < w - field_size) && ((y < field_size) || (h - y - 1 < field_size)))
                a = get_vignette_param_sin(min(y, h - y - 1), field_size);
            else
                a = 255;
		}
			break;
	}

    *v_out = (uchar4){  (v_in->r * a + v_color.r * (255 - a)) / 255,
                        (v_in->g * a + v_color.g * (255 - a)) / 255,
                        (v_in->b * a + v_color.b * (255 - a)) / 255,
                        255  };
}



