
#pragma version(1)
#pragma rs java_package_name(com.picsart.effects.rs)

#include "rs_utils.rsh"

void root(uchar4 *v_out, uint32_t x, uint32_t y) {
    int r = v_out->r;
    int g = v_out->g;
    int b = v_out->b;

    // Hue 7, Saturation 24, Lightness 9
    {
        // Convert RGB to HSL
        int h = 0, s = 0, l;
        int vmin, vmax, diff;

        vmax = vmin = r;
        if( vmax < g ) vmax = g;
        if( vmax < b ) vmax = b;
        if( vmin > g ) vmin = g;
        if( vmin > b ) vmin = b;

        diff = vmax - vmin;
        l = (vmax + vmin) / 2;

        if( diff > 0 ) {
            s = (l < 128) ? (255 * diff / (vmax + vmin)) : (255 * diff / (510 - vmax - vmin));

            if( vmax == r )
                h = (g - b) * 60 / diff;
            else if( vmax == g )
                h = (b - r) * 60 / diff + 120;
            else
                h = (r - g) * 60 / diff + 240;

            if (h < 0)
                h += 360;
        }

        // Apply correction
        h = (h + 7) % 360;
        s = min(s * 100 / 76, 255);
        l = min(l * 91 / 100 + 23, 255);

        // Convert HSL to RGB
        static const int sector_data[][3] = {{0,3,1}, {2,0,1}, {1,0,3}, {1,2,0}, {3,1,0}, {0,1,2}};

        int p2 = (l < 128) ? (l * (255 + s) / 255) : (l + s - l * s / 255);
        int p1 = 2 * l - p2;

        uchar sector = h / 60;
        h = h % 60;

        uchar tab[4];
        tab[0] = p2;
        tab[1] = p1;
        tab[2] = p1 + (p2 - p1) * (60 - h) / 60;
        tab[3] = p1 + (p2 - p1) * h / 60;

        r = tab[sector_data[sector][0]];
        g = tab[sector_data[sector][1]];
        b = tab[sector_data[sector][2]];
    }

    v_out->r = r;
    v_out->g = g;
    v_out->b = b;
}
