
#pragma version(1)
#pragma rs java_package_name(com.picsart.effects.rs)

#include "rs_utils.rsh"

static uchar red_lut[256];
static uchar green_lut[256];
static uchar blue_lut[256];

void set_params_vintage(float amount, int mode) {
    // Prepare parameters of color correction.
    float scale_r = 1.f;
    float scale_g = 1.f;
    float scale_b = 1.f;
    uchar shift_r = 0;
    uchar shift_g = 0;
    uchar shift_b = 0;
    switch (mode) {
        case 4:
            scale_r = (2.f / 8.f - 1.f) * amount + 1.f;
            shift_r = 255.f * amount * 1.f / 2.f;
            scale_g = 1.f;
            shift_g = 0.f;
            scale_b = (2.f / 8.f - 1.f) * amount + 1.f;
            shift_b = 255.f * amount * 1.f / 2.f;
            break;
        case 3:
            scale_r = (4.f / 8.f - 1.f) * amount + 1.f;
            shift_r = 255.f * amount * 1.f / 4.f;
            scale_g = (2.f / 8.f - 1.f) * amount + 1.f;
            shift_g = 255.f * amount * 1.f / 2.f;
            scale_b = (6.f / 8.f - 1.f) * amount + 1.f;
            shift_b = 255.f * amount * 1.f / 8.f;
            break;
        case 2:
            scale_r = (4.f / 8.f - 1.f) * amount + 1.f;
            shift_r = 255.f * amount * 1.f / 4.f;
            scale_g = (4.f / 8.f - 1.f) * amount + 1.f;
            shift_g = 255.f * amount * 1.f / 2.f;
            scale_b = (2.f / 8.f - 1.f) * amount + 1.f;
            shift_b = 255.f * amount * 1.f / 2.f;
            break;
        case 1:
        default:
            scale_r = (2.f / 8.f - 1.f) * amount + 1.f;
            shift_r = 255.f * amount * 1.f / 2.f;
            scale_g = (14.f / 16.f - 1.f) * amount + 1.f;
            shift_g = 255.f * amount * 1.f / 8.f;
            scale_b = (4.f / 8.f - 1.f) * amount + 1.f;
            shift_b = 255.f * amount * 1.f / 4.f;
    }

    // Prepare lookup _lut for color correction.
    for (int i = 0; i < 256; i++) {
        red_lut[i]   = scale_r * i + shift_r;
        green_lut[i] = scale_g * i + shift_g;
        blue_lut[i]  = scale_b * i + shift_b;
    }
}

void root(const uchar4 *v_in, uchar4 *v_out) {
    *v_out = (uchar4){red_lut[v_in->r], green_lut[v_in->g], blue_lut[v_in->b], 255};
}

